export const ColorLegend = ({
  colorScale,
  tickSpacing = 40,
  tickSize = 5,
  tickTextOffset = 20, 
  onHover,
  hoveredValue,
  toTitleCase
}) =>
  colorScale.domain().map((domainValue, i) => (
    <g className="tick" transform={`translate(0,${i * tickSpacing})`}
      onMouseEnter ={()=>{onHover(domainValue)}}  
        onMouseOut={() => {
        onHover(null);
      }}
      opacity={hoveredValue && domainValue !== hoveredValue ? 0.3: 1}
      >
      <circle fill={colorScale(domainValue)} r={tickSize} />
      <text x={tickTextOffset} dy=".32em">
        {toTitleCase(domainValue)}
      </text>
    </g>
  ));
