import React, { useState, useCallback, useEffect } from 'react';
import ReactDOM from 'react-dom';
import {scaleOrdinal  } from 'd3';
import { useMassGeo } from './useMassGeo';
import { useCountyData } from './useCountyData';
//import { Marks } from './Marks';
import { Marks1 } from './Marks1';
import { ColorLegend } from './ColorLegend';

const width = 960;
const height = 500;

const App = () => {
  const MassGeo = useMassGeo();
  const CountyData =useCountyData();
  const [hoveredValue, setHoveredValue] = useState(null);
  //console.log(hoveredValue)

  if (!MassGeo||!CountyData) {
    return <pre>Loading...</pre>;
  }
  
  function toTitleCase(str) {
        return str.replace(
            /\w\S*/g,
            function(txt) {
                return txt.charAt(0).toUpperCase() + txt.substr(1).toLowerCase();
            }
        );
    }

 const colorLegendLabel = "MA County";
  const circleRadius = 7;
 //console.log(CountyData);
 // console.log(MassGeo.features[0].properties.TOWN)
  //console.log(MassGeo.features.properties.TOWN)
    const getCounty = town => {
  for(let i = 0; i < CountyData.length; i++){
    if(CountyData[i].town.toUpperCase() === town.toUpperCase()){
      return CountyData[i].county;
    }
  }
};
  
   const colorValue = d => d.county; 
  const filteredMassGeo = MassGeo.features.filter (d=>hoveredValue===getCounty(d.properties.TOWN));
    const colorScale = scaleOrdinal()
    .domain(CountyData.map(colorValue))
    .range(['red', 'maroon', 'yellow', 'olive', 'lime', 'green', 'aqua', 'teal', 'blue', 'navy', 'fuchsia', 'purple', 'black', 'grey']);
		
  //console.log (colorScale('Essex'))
  //console.log(CountyData[0])
  

  //console.log(getCounty("Shrewsbury"))
  return (
    <svg width={width} height={height} viewBox="55 0 1200 700">
     
      <g transform={`translate( ${innerWidth-120}, 60)`}>
          <text
            x={35}
            y={-25}
            className="axis-label"
            textAnchor="middle"
          >
            {colorLegendLabel}
          </text>
          <ColorLegend
            tickSpacing={22}
            tickSize={10}
            tickTextOffset={12}
            tickSize={circleRadius}
            colorScale={colorScale}
            onHover = {setHoveredValue}
            hoveredValue= {hoveredValue}
            toTitleCase={toTitleCase}
          />
        </g>
        <g>
         <Marks1
          MassGeo={MassGeo}
          CountyData = {CountyData}
          colorScale = {colorScale}
          getCounty = {getCounty}
          hoveredValue= {hoveredValue}
        />
       </g> 
   
    </svg>
  );
};
const rootElement = document.getElementById('root');
ReactDOM.render(<App />, rootElement);
